diff --git a/web/pgadmin/browser/server_groups/servers/databases/schemas/tables/partitions/tests/test_backend_supported.py b/web/pgadmin/browser/server_groups/servers/databases/schemas/tables/partitions/tests/test_backend_supported.py
index a4335b41..6c2ff2a0 100644
--- a/web/pgadmin/browser/server_groups/servers/databases/schemas/tables/partitions/tests/test_backend_supported.py
+++ b/web/pgadmin/browser/server_groups/servers/databases/schemas/tables/partitions/tests/test_backend_supported.py
@@ -9,9 +9,10 @@
 
 import sys
 
-from pgadmin.browser.server_groups.servers.databases.schemas.tables.\
+from grappa import should
+
+from pgadmin.browser.server_groups.servers.databases.schemas.tables. \
     partitions import PartitionsModule
-from pgadmin.utils.route import BaseTestGenerator
 
 if sys.version_info < (3, 3):
     from mock import patch, Mock, call
@@ -19,79 +20,110 @@ else:
     from unittest.mock import patch, Mock, call
 
 
-class TestBackendSupport(BaseTestGenerator):
-    scenarios = [
-        ('when tid is not present in arguments, should return None and no '
-         'query should be done',
-         dict(
-             manager=dict(
-                 server_type="",
-                 version=""
-             ),
-             input_arguments=dict(did=432),
-
-             collection_node_active=True,
-             connection_execution_return_value=[],
-
-             expected_return_value=None,
-             expect_error_response=False,
-             expected_number_calls_on_render_template=0
-         )),
-        ('when tid is present in arguments and CollectionNodeModule does '
-         'not support, should return None and no query should be done',
-         dict(
-             manager=dict(
-                 server_type="",
-                 version=""
-             ),
-             input_arguments=dict(did=432, tid=123),
-
-             collection_node_active=False,
-             connection_execution_return_value=[],
-
-             expected_return_value=None,
-             expect_error_response=False,
-             expected_number_calls_on_render_template=0
-         )),
-        ('when table is partitioned, '
-         'should return the table identifier',
-         dict(
-             manager=dict(
-                 server_type="gpdb",
-                 version="5"
-             ),
-             input_arguments=dict(did=432, tid=123),
-
-             collection_node_active=True,
-             connection_execution_return_value=[True, 123],
-
-             expected_return_value=123,
-             expect_error_response=False,
-             expected_number_calls_on_render_template=1,
-             expect_render_template_to_be_called_with=call(
-                 'partition/sql/gpdb/#gpdb#5#/backend_support.sql', tid=123
-             )
-         )),
-        ('when error happens while querying the database, '
-         'should return an internal server error',
-         dict(
-             manager=dict(
-                 server_type="pg",
-                 version="10"
-             ),
-             input_arguments=dict(did=432, tid=123),
-
-             collection_node_active=True,
-             connection_execution_return_value=[False, "Some ugly error"],
-
-             expected_return_value=None,
-             expect_error_response=True,
-             expected_number_calls_on_render_template=1,
-             expect_render_template_to_be_called_with=call(
-                 'partition/sql/pg/#pg#10#/backend_support.sql', tid=123
-             )
-         ))
-    ]
+class TestBackendSupport:
+    @patch(
+        'pgadmin.browser.server_groups.servers.databases.schemas.tables.'
+        'partitions.CollectionNodeModule'
+    )
+    @patch(
+        'pgadmin.browser.server_groups.servers.databases.schemas.tables.'
+        'partitions.render_template'
+    )
+    def test_not_all_arguments_present(
+        self, render_template_mock, CollectionNodeModule_mock
+    ):
+        """
+        When tid is not present in the arguments
+        It return None and no query should be done
+        """
+        module = PartitionsModule('partition')
+        module.manager = Mock()
+        module.manager.server_type = ''
+        module.manager.version = ''
+        connection_mock = Mock()
+        connection_mock.execute_scalar.return_value = []
+        module.manager.connection.return_value = connection_mock
+        CollectionNodeModule_mock.BackendSupported.return_value = True
+
+        result = module.BackendSupported(
+            module.manager,
+            did=432
+        )
+
+        render_template_mock.assert_not_called()
+
+        result | should.be.none
+
+    @patch(
+        'pgadmin.browser.server_groups.servers.databases.schemas.tables.'
+        'partitions.CollectionNodeModule'
+    )
+    @patch(
+        'pgadmin.browser.server_groups.servers.databases.schemas.tables.'
+        'partitions.render_template'
+    )
+    def test_tid_present_not_supported(
+        self, render_template_mock, CollectionNodeModule_mock
+    ):
+        """
+        when tid is present in arguments
+        And CollectionNodeModule does not support
+        It return None and no query should be done
+        """
+        module = PartitionsModule('partition')
+        module.manager = Mock()
+        module.manager.server_type = ''
+        module.manager.version = ''
+        connection_mock = Mock()
+        connection_mock.execute_scalar.return_value = []
+        module.manager.connection.return_value = connection_mock
+        CollectionNodeModule_mock.BackendSupported.return_value = False
+
+        result = module.BackendSupported(
+            module.manager,
+            did=432,
+            tid=123
+        )
+
+        render_template_mock.assert_not_called()
+
+        result | should.be.none
+
+    @patch(
+        'pgadmin.browser.server_groups.servers.databases.schemas.tables.'
+        'partitions.CollectionNodeModule'
+    )
+    @patch(
+        'pgadmin.browser.server_groups.servers.databases.schemas.tables.'
+        'partitions.render_template'
+    )
+    def test_table_partitioned(
+        self, render_template_mock, CollectionNodeModule_mock
+    ):
+        """
+        When table is partitioned
+        It return the table identifier
+        """
+        module = PartitionsModule('partition')
+        module.manager = Mock()
+        module.manager.server_type = 'gpdb'
+        module.manager.version = '5'
+        connection_mock = Mock()
+        connection_mock.execute_scalar.return_value = [True, 123]
+        module.manager.connection.return_value = connection_mock
+        CollectionNodeModule_mock.BackendSupported.return_value = True
+
+        result = module.BackendSupported(
+            module.manager,
+            did=432,
+            tid=123
+        )
+
+        render_template_mock.assert_has_calls(
+            [call('partition/sql/gpdb/#gpdb#5#/backend_support.sql', tid=123)]
+        )
+
+        result | should.be.equal.to(123)
 
     @patch(
         'pgadmin.browser.server_groups.servers.databases.schemas.tables.'
@@ -105,35 +137,35 @@ class TestBackendSupport(BaseTestGenerator):
         'pgadmin.browser.server_groups.servers.databases.schemas.tables.'
         'partitions.render_template'
     )
-    def runTest(
+    def test_error_while_querying_database(
         self, render_template_mock, CollectionNodeModule_mock,
         internal_server_error_mock
     ):
-        module = PartitionsModule("partition")
+        """
+        When error happens while querying the database
+        It return an internal server error
+        """
+        module = PartitionsModule('partition')
         module.manager = Mock()
-        module.manager.server_type = self.manager['server_type']
-        module.manager.version = self.manager['version']
+        module.manager.server_type = 'pg'
+        module.manager.version = '10'
         connection_mock = Mock()
-        connection_mock.execute_scalar.return_value = \
-            self.connection_execution_return_value
+        connection_mock.execute_scalar.return_value = [
+            False,
+            'Some ugly error']
         module.manager.connection.return_value = connection_mock
-        CollectionNodeModule_mock.BackendSupported.return_value = \
-            self.collection_node_active
+        CollectionNodeModule_mock.BackendSupported.return_value = True
 
-        result = module.BackendSupported(
-            module.manager, **self.input_arguments
+        module.BackendSupported(
+            module.manager,
+            did=432,
+            tid=123
         )
 
-        if self.expected_number_calls_on_render_template == 0:
-            render_template_mock.assert_not_called()
-        else:
-            render_template_mock.assert_has_calls(
-                [self.expect_render_template_to_be_called_with]
-            )
-
-        if self.expect_error_response:
-            internal_server_error_mock.assert_called_with(
-                errormsg=self.connection_execution_return_value[1]
-            )
-        else:
-            self.assertEqual(result, self.expected_return_value)
+        render_template_mock.assert_has_calls(
+            [call('partition/sql/pg/#pg#10#/backend_support.sql', tid=123)]
+        )
+
+        internal_server_error_mock.assert_called_with(
+            errormsg='Some ugly error'
+        )
diff --git a/web/pgadmin/browser/server_groups/servers/databases/schemas/tables/rules/tests/__init__.py b/web/pgadmin/browser/server_groups/servers/databases/schemas/tables/rules/tests/__init__.py
index d1f2ecc1..590026ad 100644
--- a/web/pgadmin/browser/server_groups/servers/databases/schemas/tables/rules/tests/__init__.py
+++ b/web/pgadmin/browser/server_groups/servers/databases/schemas/tables/rules/tests/__init__.py
@@ -6,11 +6,3 @@
 # This software is released under the PostgreSQL Licence
 #
 ##########################################################################
-
-from pgadmin.utils.route import BaseTestGenerator
-
-
-class RulesTestGenerator(BaseTestGenerator):
-
-    def runTest(self):
-        return []
diff --git a/web/pgadmin/browser/server_groups/servers/databases/schemas/tables/rules/tests/test_rules_add.py b/web/pgadmin/browser/server_groups/servers/databases/schemas/tables/rules/tests/test_rules_add.py
index 3955860a..9dcb265e 100644
--- a/web/pgadmin/browser/server_groups/servers/databases/schemas/tables/rules/tests/test_rules_add.py
+++ b/web/pgadmin/browser/server_groups/servers/databases/schemas/tables/rules/tests/test_rules_add.py
@@ -10,61 +10,66 @@
 import json
 import uuid
 
+import pytest
+from grappa import should
+
 from pgadmin.browser.server_groups.servers.databases.schemas.tables.tests \
     import utils as tables_utils
 from pgadmin.browser.server_groups.servers.databases.schemas.tests import \
     utils as schema_utils
-from pgadmin.browser.server_groups.servers.databases.tests import utils as \
-    database_utils
-from pgadmin.utils.route import BaseTestGenerator
-from regression import parent_node_dict
+from pgadmin.utils.tests_helper import convert_response_to_json, \
+    assert_json_values_from_response
 from regression.python_test_utils import test_utils as utils
 
 
-class RulesAddTestCase(BaseTestGenerator):
-    """This class will add new rule under table node."""
-    scenarios = [
-        ('Add rule Node URL', dict(url='/browser/rule/obj/'))
-    ]
+class TestRulesAdd:
+    @pytest.mark.usefixtures('require_database_connection')
+    def test_rule_add(self, context_of_tests):
+        """
+        When the rule add request is send to the backend
+        it returns 200 status
+        """
+        http_client = context_of_tests['test_client']
+        server = context_of_tests['server']
+        server_data = context_of_tests['server_information']
 
-    def setUp(self):
-        self.db_name = parent_node_dict["database"][-1]["db_name"]
-        schema_info = parent_node_dict["schema"][-1]
-        self.server_id = schema_info["server_id"]
-        self.db_id = schema_info["db_id"]
-        db_con = database_utils.connect_database(self, utils.SERVER_GROUP,
-                                                 self.server_id, self.db_id)
-        if not db_con['data']["connected"]:
-            raise Exception("Could not connect to database to add a rule.")
-        self.schema_id = schema_info["schema_id"]
-        self.schema_name = schema_info["schema_name"]
-        schema_response = schema_utils.verify_schemas(self.server,
-                                                      self.db_name,
-                                                      self.schema_name)
+        db_name = server_data['db_name']
+        server_id = server_data['server_id']
+        db_id = server_data['db_id']
+        schema_id = server_data['schema_id']
+        schema_name = server_data['schema_name']
+        schema_response = schema_utils.verify_schemas(server,
+                                                      db_name,
+                                                      schema_name)
         if not schema_response:
-            raise Exception("Could not find the schema to add a rule.")
-        self.table_name = "table_column_%s" % (str(uuid.uuid4())[1:8])
-        self.table_id = tables_utils.create_table(self.server, self.db_name,
-                                                  self.schema_name,
-                                                  self.table_name)
+            raise Exception('Could not find the schema to add a rule.')
+        table_name = 'table_column_%s' % (str(uuid.uuid4())[1:8])
+        table_id = tables_utils.create_table(server, db_name,
+                                             schema_name,
+                                             table_name)
 
-    def runTest(self):
-        """This function will rule under table node."""
-        rule_name = "test_rule_add_%s" % (str(uuid.uuid4())[1:8])
-        data = {"schema": self.schema_name,
-                "view": self.table_name,
-                "name": rule_name,
-                "event": "Update"
+        rule_name = 'test_rule_add_%s' % (str(uuid.uuid4())[1:8])
+        data = {'schema': schema_name,
+                'view': table_name,
+                'name': rule_name,
+                'event': 'Update'
                 }
-        response = self.tester.post(
-            "{0}{1}/{2}/{3}/{4}/{5}/".format(self.url, utils.SERVER_GROUP,
-                                             self.server_id, self.db_id,
-                                             self.schema_id, self.table_id),
+        url = '/browser/rule/obj/'
+        response = http_client.post(
+            '{0}{1}/{2}/{3}/{4}/{5}/'.format(url, utils.SERVER_GROUP,
+                                             server_id, db_id,
+                                             schema_id, table_id),
             data=json.dumps(data),
             content_type='html/json'
         )
-        self.assertEquals(response.status_code, 200)
 
-    def tearDown(self):
-        # Disconnect the database
-        database_utils.disconnect_database(self, self.server_id, self.db_id)
+        response.status_code | should.be.equal.to(200)
+        json_response = convert_response_to_json(response)
+        assert_json_values_from_response(
+            json_response,
+            'rule',
+            'pgadmin.node.rule',
+            False,
+            'icon-rule',
+            rule_name
+        )
diff --git a/web/pgadmin/browser/server_groups/servers/databases/schemas/tables/rules/tests/test_rules_delete.py b/web/pgadmin/browser/server_groups/servers/databases/schemas/tables/rules/tests/test_rules_delete.py
index 39830fd2..8fb2c645 100644
--- a/web/pgadmin/browser/server_groups/servers/databases/schemas/tables/rules/tests/test_rules_delete.py
+++ b/web/pgadmin/browser/server_groups/servers/databases/schemas/tables/rules/tests/test_rules_delete.py
@@ -9,65 +9,67 @@
 
 import uuid
 
+import pytest
+from grappa import should
+
 from pgadmin.browser.server_groups.servers.databases.schemas.tables.tests \
     import utils as tables_utils
 from pgadmin.browser.server_groups.servers.databases.schemas.tests import \
     utils as schema_utils
-from pgadmin.browser.server_groups.servers.databases.tests import utils as \
-    database_utils
-from pgadmin.utils.route import BaseTestGenerator
-from regression import parent_node_dict
+from pgadmin.utils.tests_helper import convert_response_to_json
 from regression.python_test_utils import test_utils as utils
 from . import utils as rules_utils
 
 
-class RulesDeleteTestCase(BaseTestGenerator):
-    """This class will delete rule under table node."""
-    scenarios = [
-        ('Delete rule Node URL', dict(url='/browser/rule/obj/'))
-    ]
+class TestRulesDelete:
+    @pytest.mark.usefixtures('require_database_connection')
+    def test_rule_delete(self, context_of_tests):
+        """
+        When the rule DELETE request is send to the backend
+        it returns 200 status
+        """
+        http_client = context_of_tests['test_client']
+        server = context_of_tests['server']
+        server_data = context_of_tests['server_information']
 
-    def setUp(self):
-        self.db_name = parent_node_dict["database"][-1]["db_name"]
-        schema_info = parent_node_dict["schema"][-1]
-        self.server_id = schema_info["server_id"]
-        self.db_id = schema_info["db_id"]
-        db_con = database_utils.connect_database(self, utils.SERVER_GROUP,
-                                                 self.server_id, self.db_id)
-        if not db_con['data']["connected"]:
-            raise Exception("Could not connect to database to delete rule.")
-        self.schema_id = schema_info["schema_id"]
-        self.schema_name = schema_info["schema_name"]
-        schema_response = schema_utils.verify_schemas(self.server,
-                                                      self.db_name,
-                                                      self.schema_name)
+        db_name = server_data['db_name']
+        server_id = server_data['server_id']
+        db_id = server_data['db_id']
+        schema_id = server_data['schema_id']
+        schema_name = server_data['schema_name']
+        schema_response = schema_utils.verify_schemas(server,
+                                                      db_name,
+                                                      schema_name)
         if not schema_response:
-            raise Exception("Could not find the schema to delete rule.")
-        self.table_name = "table_column_%s" % (str(uuid.uuid4())[1:8])
-        self.table_id = tables_utils.create_table(self.server, self.db_name,
-                                                  self.schema_name,
-                                                  self.table_name)
-        self.rule_name = "test_rule_delete_%s" % (str(uuid.uuid4())[1:8])
-        self.rule_id = rules_utils.create_rule(self.server, self.db_name,
-                                               self.schema_name,
-                                               self.table_name,
-                                               self.rule_name)
+            raise Exception('Could not find the schema to delete rule.')
+        table_name = 'table_column_%s' % (str(uuid.uuid4())[1:8])
+        table_id = tables_utils.create_table(server, db_name,
+                                             schema_name,
+                                             table_name)
+        rule_name = 'test_rule_delete_%s' % (str(uuid.uuid4())[1:8])
+        rule_id = rules_utils.create_rule(server, db_name,
+                                          schema_name,
+                                          table_name,
+                                          rule_name)
 
-    def runTest(self):
-        """This function will delete rule under table node."""
-        rule_response = rules_utils.verify_rule(self.server, self.db_name,
-                                                self.rule_name)
+        rule_response = rules_utils.verify_rule(server, db_name,
+                                                rule_name)
         if not rule_response:
-            raise Exception("Could not find the rule to delete.")
-        response = self.tester.delete(
-            "{0}{1}/{2}/{3}/{4}/{5}/{6}".format(self.url, utils.SERVER_GROUP,
-                                                self.server_id, self.db_id,
-                                                self.schema_id, self.table_id,
-                                                self.rule_id),
+            raise Exception('Could not find the rule to delete.')
+        url = '/browser/rule/obj/'
+        response = http_client.delete(
+            '{0}{1}/{2}/{3}/{4}/{5}/{6}'.format(url, utils.SERVER_GROUP,
+                                                server_id, db_id,
+                                                schema_id, table_id,
+                                                rule_id),
             follow_redirects=True
         )
-        self.assertEquals(response.status_code, 200)
 
-    def tearDown(self):
-        # Disconnect the database
-        database_utils.disconnect_database(self, self.server_id, self.db_id)
+        response.status_code | should.be.equal.to(200)
+        json_response = convert_response_to_json(response)
+        json_response | should.have.key('info') > should.be.equal.to(
+            'Rule dropped')
+        json_response | should.have.key('errormsg') > should.be.empty
+        json_response | should.have.key('data')
+        json_response | should.have.key('result') > should.be.none
+        json_response | should.have.key('success') > should.be.equal.to(1)
diff --git a/web/pgadmin/browser/server_groups/servers/databases/schemas/tables/rules/tests/test_rules_get.py b/web/pgadmin/browser/server_groups/servers/databases/schemas/tables/rules/tests/test_rules_get.py
index 0250f087..50391004 100644
--- a/web/pgadmin/browser/server_groups/servers/databases/schemas/tables/rules/tests/test_rules_get.py
+++ b/web/pgadmin/browser/server_groups/servers/databases/schemas/tables/rules/tests/test_rules_get.py
@@ -9,61 +9,76 @@
 
 import uuid
 
+import pytest
+from grappa import should
+
 from pgadmin.browser.server_groups.servers.databases.schemas.tables.tests \
     import utils as tables_utils
 from pgadmin.browser.server_groups.servers.databases.schemas.tests import \
     utils as schema_utils
-from pgadmin.browser.server_groups.servers.databases.tests import utils as \
-    database_utils
-from pgadmin.utils.route import BaseTestGenerator
-from regression import parent_node_dict
+from pgadmin.utils.tests_helper import convert_response_to_json
 from regression.python_test_utils import test_utils as utils
 from . import utils as rules_utils
 
 
-class RulesGetTestCase(BaseTestGenerator):
-    """This class will fetch the rule under table node."""
-    scenarios = [
-        ('Fetch rule Node URL', dict(url='/browser/rule/obj/'))
-    ]
+class TestRulesGet:
+    @pytest.mark.usefixtures('require_database_connection')
+    def test_rule_get(self, context_of_tests):
+        """
+        When the rule GET request is send to the backend
+        it returns 200 status
+        """
+        http_client = context_of_tests['test_client']
+        server = context_of_tests['server']
+        server_data = context_of_tests['server_information']
 
-    def setUp(self):
-        self.db_name = parent_node_dict["database"][-1]["db_name"]
-        schema_info = parent_node_dict["schema"][-1]
-        self.server_id = schema_info["server_id"]
-        self.db_id = schema_info["db_id"]
-        db_con = database_utils.connect_database(self, utils.SERVER_GROUP,
-                                                 self.server_id, self.db_id)
-        if not db_con['data']["connected"]:
-            raise Exception("Could not connect to database to delete rule.")
-        self.schema_id = schema_info["schema_id"]
-        self.schema_name = schema_info["schema_name"]
-        schema_response = schema_utils.verify_schemas(self.server,
-                                                      self.db_name,
-                                                      self.schema_name)
+        db_name = server_data['db_name']
+        server_id = server_data['server_id']
+        db_id = server_data['db_id']
+        schema_id = server_data['schema_id']
+        schema_name = server_data['schema_name']
+        schema_response = schema_utils.verify_schemas(server,
+                                                      db_name,
+                                                      schema_name)
         if not schema_response:
-            raise Exception("Could not find the schema to delete rule.")
-        self.table_name = "table_column_%s" % (str(uuid.uuid4())[1:8])
-        self.table_id = tables_utils.create_table(self.server, self.db_name,
-                                                  self.schema_name,
-                                                  self.table_name)
-        self.rule_name = "test_rule_delete_%s" % (str(uuid.uuid4())[1:8])
-        self.rule_id = rules_utils.create_rule(self.server, self.db_name,
-                                               self.schema_name,
-                                               self.table_name,
-                                               self.rule_name)
+            raise Exception('Could not find the schema to delete rule.')
+
+        table_name = 'table_column_%s' % (str(uuid.uuid4())[1:8])
+        table_id = tables_utils.create_table(server,
+                                             db_name,
+                                             schema_name,
+                                             table_name)
+        rule_name = 'test_rule_get_%s' % (str(uuid.uuid4())[1:8])
+        rule_id = rules_utils.create_rule(server,
+                                          db_name,
+                                          schema_name,
+                                          table_name,
+                                          rule_name)
 
-    def runTest(self):
-        """This function will fetch the rule under table node."""
-        response = self.tester.get(
-            "{0}{1}/{2}/{3}/{4}/{5}/{6}".format(self.url, utils.SERVER_GROUP,
-                                                self.server_id, self.db_id,
-                                                self.schema_id, self.table_id,
-                                                self.rule_id),
+        url = '/browser/rule/obj/'
+        response = http_client.get(
+            '{0}{1}/{2}/{3}/{4}/{5}/{6}'.format(url, utils.SERVER_GROUP,
+                                                server_id, db_id,
+                                                schema_id, table_id,
+                                                rule_id),
             follow_redirects=True
         )
-        self.assertEquals(response.status_code, 200)
 
-    def tearDown(self):
-        # Disconnect the database
-        database_utils.disconnect_database(self, self.server_id, self.db_id)
+        response.status_code | should.be.equal.to(200)
+        json_response = convert_response_to_json(response)
+        json_response | should.have.key('comment') > should.be.none
+        json_response | should.have.key('definition')
+        json_response | should.have.key('statements') > should.be.equal.to(
+            'NOTHING;')
+        json_response | should.have.key('name') > should.be.equal.to(rule_name)
+        json_response | should.have.key('parentistable') > should.be.true
+        json_response | should.have.key('do_instead') > should.be.false
+        json_response | should.have.key('oid')
+        json_response | should.have.key('enabled') > should.be.true
+        json_response | should.have.key('system_rule') > should.be.false
+        json_response | should.have.key('view') > should.be.equal.to(
+            table_name)
+        json_response | should.have.key('event') > should.be.equal.to('Update')
+        json_response | should.have.key('condition') > should.be.equal.to('')
+        json_response | should.have.key('schema') > should.be.equal.to(
+            schema_name)
